import java.util.*;
/**
   Este programa genera un arbol rojo_negro ordenado por el codigo del objeto 
   item y otro ordenado por valor. 
*/
public class TreeSetTest02{  
    public static void main(String[] args){
       TreeSetTest02 arbolTest = new TreeSetTest02();
       arbolTest.demo();
    }
    
    public void demo(){
        ArrItems aItem = new ArrItems(20,'R');
        
        // Arbol ordenado por cdigo de items
        ComparaCodigo compCod = new ComparaCodigo(); 
        TreeSet arbol = new TreeSet(compCod);
        for(int i=0;i<aItem.talle;i++)
            arbol.add(aItem.item[i]);
        System.out.println("El arbol de items, ordenado por codigo");
        System.out.println(arbol);
        
        // Arbol ordenado por valor de items
        ComparaValor compVal = new ComparaValor(); 
                arbol = new TreeSet(compVal);
        for(int i=0;i<aItem.talle;i++)
            arbol.add(aItem.item[i]);
        System.out.println("El arbol de items, ordenado por Valor");
        System.out.println(arbol);
    }
}

class ComparaCodigo implements Comparator{
    public int compare(Object a, Object b){
        Item itemA = (Item)a; 
        Item itemB = (Item)b;
        int codA   = itemA.getCodigo();
        int codB   = itemB.getCodigo();
        return codA - codB;
    }
}

class ComparaValor implements Comparator{
    public int compare(Object a, Object b){
        Item itemA = (Item)a; 
        Item itemB = (Item)b;
        int valA   = (int)itemA.getValor()*100;
        int valB   = (int)itemB.getValor()*100;
        return valA - valB;
    }
}


