import java.util.*;
import java.io.*;

/**
   Este programa utiliza el comportamiento de un conjunto (HashSet)
 * para mostrar las palabras introducidas desde System.in, ignorando 
 * repeticiones
*/
public class SetTest{ 
   public static void main(String[] args){  
      Set palabras = new HashSet(); 
      // una referencia de Set puede ser instanciada con objetos
      // HashSet, LinkedHashSet or TreeSet
      int leidas    = 0;
      int lineas    = 0;
      try{  
         BufferedReader in = new
                BufferedReader(new InputStreamReader(System.in));
         String line;
         System.out.println("Introduzca texto desde System.in");
         while (lineas < 2){
             line = in.readLine();
             lineas++;
             System.out.println(line);
             StringTokenizer tokenizer = new StringTokenizer(line);
             while (tokenizer.hasMoreTokens()){  
                String palabra = tokenizer.nextToken();
                palabras.add(palabra);
                leidas++;
            }   //  while
         }  //  while
      } //  try
      catch (IOException e){  
         System.out.println("Error " + e);
      }

      Iterator iter = palabras.iterator();
      System.out.println("Iteramos ...");
      int contPalLin = 0;
      while (iter.hasNext()){
        System.out.print(iter.next()+", ");
        if(++contPalLin>5){System.out.println();contPalLin = 0;}
      }
        System.out.println("\nTotal palabras leidas   "+leidas);
        System.out.println("Total palabras distint. "+palabras.size());
   }
}
